<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Discos Asier</title>
</head>

<body>
    <script>
        class Interprete {
            #nombre;
            #apellidos;
            #nombreArtistico;

            constructor(nombre, apellidos, nombreArtistico) {
                this.#nombre = nombre;
                this.#apellidos = apellidos;
                this.#nombreArtistico = nombreArtistico;
            }

            get nombreArtistico() {
                return this.#nombreArtistico;
            }

            set nombreArtistico(nuevoNombreArtistico) {
                this.#nombreArtistico = nuevoNombreArtistico;
            }
        }

        class Disco {
            nombre;
            interprete;
            añoPublicacion;
            tipoMusica;
            urlCaratula;
            #localizacion;
            #prestado;

            constructor() {
                this.nombre = "";
                this.interprete = new Interprete("", "", "");
                this.añoPublicacion = "";
                this.tipoMusica = "";
                this.urlCaratula = "";
                this.#localizacion = 0;
                this.#prestado = false;
            }

            agregarDisco(nombre, interprete, añoPublicacion, tipoMusica, urlCaratula, localizacion) {
                this.nombre = nombre;
                this.interprete = interprete;
                this.añoPublicacion = añoPublicacion;
                this.tipoMusica = tipoMusica;
                this.urlCaratula = urlCaratula;
                this.#localizacion = localizacion;
                this.#prestado = false;
            }

            mostrarDisco() {
                console.log(`\n${this.nombre}`);
                console.log(`------------------------`);
                console.log(`Intérprete: ${this.interprete.nombreArtistico}`);
                console.log(`Año de publicación: ${this.añoPublicacion}`);
                console.log(`Tipo de música: ${this.tipoMusica}`);
                console.log(`Url de la carátula: ${this.urlCaratula}`);
            }
        }

        class Discografia {
            #discos;

            constructor() {
                this.#discos = [];
            }

            agregarDisco(disco) {
                this.#discos.push(disco);
            }

            borrarDisco(disco) {
                const indice = this.#discos.indexOf(disco);
                if (indice !== -1) {
                    this.#discos.splice(indice, 1);
                }
            }

            ordenarDiscos(atributo) {
                this.#discos.sort((a, b) =>
                    a[atributo] > b[atributo] ? 1 : -1);
            }

            mostrarDiscografia() {
                this.#discos.forEach((disco) => {
                    disco.mostrarDisco();
                });
            }
        }

        // Crear algunos discos para probar
        const interprete1 = new Interprete("Pedro", "Domínguez", "Quevedo");
        const interprete2 = new Interprete("Mauro Ezequiel", "Lombardo Quiroga", "Duki");
        const interprete3 = new Interprete("Benito Antonio", "Martínez Ocasio", "Bad Bunny");
        const interprete4 = new Interprete("Michael Anthony", "Torres Monger", "Myke Towers");
        const interprete5 = new Interprete("Enmanuel", "Gazmey", "Anuel AA");

        const disco1 = new Disco();
        disco1.agregarDisco("Donde quiero estar", interprete1, "2023", "Pop Urbano", "https://i.scdn.co/image/ab67616d00001e02efc1b8f6beda4abe848a84e0");

        const disco2 = new Disco();
        disco2.agregarDisco("Temporada de Reggaetón", interprete2, "2022", "Trap / Reggaetón", "https://images.genius.com/bc9affe546b293350096f13ddff87eee.1000x1000x1.png");

        const disco3 = new Disco();
        disco3.agregarDisco("Un Verano Sin Ti", interprete3, "2022", "Regaetón", "https://m.media-amazon.com/images/I/91vkwlCj4mL._SL1500_.jpg");

        const disco4 = new Disco();
        disco4.agregarDisco("LYKE MIKE", interprete4, "2021", "Reggaetón", "https://i.scdn.co/image/ab67616d0000b273c09ae45aa7c410ca6d194ded");

        const disco5 = new Disco();
        disco5.agregarDisco("LLNM2", interprete5, "2022", "Trap", "https://i.scdn.co/image/ab67616d0000b273a726edfbadc78b7397c78eda");

        const discografia = new Discografia();
        discografia.agregarDisco(disco1);
        discografia.agregarDisco(disco2);
        discografia.agregarDisco(disco3);
        discografia.agregarDisco(disco4);
        discografia.agregarDisco(disco5);

        console.log("############################################");
        console.log("Discografía ordenada por año de publicación:");
        console.log("############################################");
        discografia.ordenarDiscos("añoPublicacion");
        discografia.mostrarDiscografia();
        console.log("########################################");
        console.log("Discografía ordenada por tipo de música:");
        console.log("########################################");
        discografia.ordenarDiscos("tipoMusica");
        discografia.mostrarDiscografia();
        console.log("########################################");
        console.log("Discografia ordenada por artista: Ordena por nombre real, no artístico! :(");
        console.log("########################################");
        discografia.ordenarDiscos("interprete");
        discografia.mostrarDiscografia();
        console.log("########################################");
        console.log("Discografía ordenada por nombre del disco:");
        console.log("########################################");
        discografia.ordenarDiscos("nombre");
        discografia.mostrarDiscografia();


    </script>
</body>

</html>